/*
 ========================================================
 IMPORTANT: GOTO lines 17, 57, 92 to configure some data!
 ========================================================
 Ruud Boer October 2014
 DCC Servo and Function Decoder.
 Many thanks to www.mynabay.com for publishing their DCC monitor and -decoder code, which is used in this sketch.
 PURPOSE:
 This sketch turns an Arduino into a DCC decoder with max 16x function outputs and/or max 12 servo outputs. 
 The DCC signal is optically separated and fed to pin 2 Interrupt 0. Schematics: www.mynabay.com

 Adapted by Xavier Bouillard March 2016
 
 ========================================================
*/

//#include <extEEPROM.h>    //http://github.com/JChristensen/extEEPROM/tree/dev
#include <DCC_Decoder.h>
#define kDCC_INTERRUPT 0
#include <Servo.h> 
#include <EEPROM.h>
//#include <LiquidCrystal_I2C.h>
//LiquidCrystal_I2C lcd(0x27,20,2); // set the LCD address to 0x27 for a 16 chars and 2 line display
//#include <Music.h>

// ========================================================
// Variables et constantes
// ========================================================
int speedPN = 20;
#define stepPN 1
int tempoPN = 5000;
unsigned long previousPNMillis = 0;          // will store last time LED was updated
unsigned long previousMoveMillis = 0;        // will store last time LED was updated
unsigned long previousMoveStepMillis = 0;    // will store last time LED was updated
int MinValue[16]= {0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75};
int MaxValue[16]= {25,30,35,40,45,50,120,60,65,70,75,80,85,90,95,100};
int MoveValue[16]= {0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75};
unsigned long previousBlinkMillis = 0;        // will store last time LED was updated
unsigned long previousBlinkStepMillis = 0;    // will store last time LED was updated
#define ledPin 13
#define speedFade 2
#define stepFade 5
int Period = 1000;
int ledState = LOW;
int fadeValue[16]= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
Servo PnServo[2];      // PN servos
int LedPin[4];         // PN leds 
int Mode=0;            // Detection Dcc
int SelServo=-1;
// ========================================================
// FILL IN 
// ========================================================
const byte maxfunctions=14; //The number of functions you want to control with this Arduino
#define FirstPin 3     
#define PowerPin 13         //Power On/off for all servos at once.
int timer = 300;            //Servo angle update timer. Lower value -> higher speed
int cptDown;
int cptUp;
//#define DccBaseAdress  200

boolean StartPhase = true;

// byte led=13;               //YD0227 POWER
byte clockwise=true; //true means servo, looking at the axle, runs clockwise, false counter-clockwise
unsigned long DccAction = millis() + timer;
boolean done=false;
byte temp=0;

typedef struct {
    byte              Etat;            // State of output 1=on, 0=off
    int               DccValue;        // Arduino output pin
    int               PinNr;           // Arduino output pin
} function;

function gfunction[16];

typedef struct {
    int               address;         // Address to respond to
    byte              output;          // State of output 1=on, 0=off
    int               outputPin;       // Arduino output pin
//    boolean           isDigital;       // true=digital, false=analog, sends analogValue to pin.
//    boolean           isFlasher;       // true=flash output, false=no time, no flash.
//    byte              analogValue;     // Value to send out if analog output.
//    int               durationMilli;   // ms flash time. 0 = don't auto off
//
//    unsigned long     onMilli;         // for internal use
//    unsigned long     offMilli;        // for internal use
} DCCAccessoryAddress;

DCCAccessoryAddress gAddresses[maxfunctions];

int DccBaseAdress;    // Adresse de base DCC
int S;                // Servo selectionné
int Debut;            // Valeur Debut
int Fin;              // Valeur Fin

int btn=-1;
int numBtn1=-1;
int numBtn2=-1;

// ========================================================
// Gestion de la communication PC via USB
String inputString = "";        // Chaine permettant de recevoir les informations du PC via USB
boolean stringComplete = false; // Drapeau indiquant que la chaine recue est complete (finit par CR)
int LastMsg =0;
 
boolean Power=LOW;

//Two 24LC256 EEPROMs on the bus
const uint32_t totalKBytes = 64;         //for read and write test functions
//extEEPROM I2C_eep(kbits_256, 1, 64);         //device size, number of devices, page size

// ========================================================
// Eeprom mapping
// ========================================================
#define Eeprom  0
// Eeprom                : DccBaseAdress (2)        0 1
// Eeprom+2n+2           : minangle (n)             2 4 6 8 10 12 14 16
// Eeprom+2n+3           : maxangle (n)             3 5 7 9 11 13 15 17
// Eeprom+30+n           : power off angle (n)      30 31 32 33 34 35 36 37
// Eeprom+40+n           : Output (n)               40 41 42 43 44 45 46 47
// Eeprom+50             : Speed Servo (1)          50
// Eeprom+52             : Speed blink (2)          52 53
// Eeprom+54             : Tempo PN (2)             54 55
// ========================================================

// ========================================================
// USB console interface. 
// cmd syntax :2 digits, first digit is action (0 or 1 to commute servo) & second digit for servo index
// example 12 means "put ON servo number 2"
// cmd syntax: letter + number, letter is cmd as per table below, number is the new value for relevant variable
// ========================================================
#define  Msg_Patience          "Patientez S.V.P."
#define  Msg_Recu_USB           "------ Recu : "

#define  Cmd_DccAdress         "A" // Adresse de base DCC (memorisation immediate)
#define  Msg_DccAdress         "Adresse "
#define  Cmd_DccMode           "M" // Detection Adresse de base DCC (memorisation immediate)
#define  Msg_DccMode           "Mode Dcc "
#define  Cmd_Cmd               "C" // Commande Dcc
#define  Msg_Cmd               "Commande "
#define  Cmd_Move              "V" // Vitesse de deplacement
#define  Msg_Move              "Vitesse Servo"
#define  Cmd_RNr               "S" // Selection Servo
#define  Msg_RNr               "Select Servo"
#define  Cmd_RMin              "B" // Reglage Angle Mini
#define  Msg_RMin              "Reglage Angle Mini"
#define  Cmd_RMax              "H" // Reglage Angle Maxi
#define  Msg_RMax              "Reglage Angle Maxi"
#define  Cmd_Toggle            "T" // Vitesse de clignotement
#define  Msg_Toggle            "Vitesse clignotement"
#define  Cmd_Delay             "D" // Temporisation Feux PN
#define  Msg_Delay             "Tempo Feux PN"
#define  Cmd_List              "L" // List des commandes disponibles
#define  Msg_List              "Liste "
#define  Cmd_Help              "?" // Aide (commandes disponibles)
#define  Msg_Help              "Aide" // pour Aide

#define  Cmd_Store_actual      "X" // Memorisation positions actuelles des servos
#define  Msg_Store_actual      "Save Parameters" // positions actuelles des servos
#define  Cmd_Dump              "Y" // Dump Eeprom
#define  Msg_Dump              "Dump Eeprom" // Dump Eeprom

#define  Msg_Id                "Id "
#define  Cmd_Id                "W" // Who (identification module)
#define  Msg_Servo             "Dcc PN V1"



// ========================================================
// DCC Function Decoder Init: COPY - PASTE as many times as you have outputs
//(and/or connected servos, see below) and fill in the values you want gfor your outputs.
// ========================================================

void ConfigureDecoderFunctions() { // The amount must be as in line 12 above!
  Serial.println("ConfigureDecoderFunctions");
  for(int i=0; i<maxfunctions; i++) {
    gAddresses[i].address = DccBaseAdress+i;
    //gAddresses[i].output = 0;
    gAddresses[i].outputPin = i+FirstPin;  //
//    gAddresses[i].durationMilli = 0;       // if a servo is coupled set this at 0! 
  }
   
//  // Setup output pins for Functions
//  for(int i=0; i<maxfunctions; i++) {
////    if( gAddresses[i].outputPin ) {
////      pinMode( gAddresses[i].outputPin, OUTPUT );
////    }
//    //gAddresses[i].onMilli = 0;
//    //gAddresses[i].offMilli = 0;
//  }
}

// ========================================================
// Basic accessory packet handler 
// ========================================================

void BasicAccDecoderPacket_Handler(int address, boolean activate, byte data) {
  // Convert Dcc address to human comprehensible
  address -= 1;
  address *= 4;
  address += 1;
  address += (data & 0x06) >> 1;
    
  boolean enable = (data & 0x01) ? 1 : 0;
  int msg=data;
  String Msg;
  if (LastMsg != msg) { 
    Serial.print("S ");
    Serial.print(address);
    Serial.print(" (");
    Serial.print(address-DccBaseAdress);
    Serial.print(") ");
    Serial.println(enable,DEC);        
    LastMsg = msg;
    DccAction = millis();
    switch (Mode) {
      case 0:   
        for(int i=0; i<maxfunctions; i++) {
          if( address == gAddresses[i].address ) {
            if( enable ) {
              gAddresses[i].output = 1;
            } else {
              gAddresses[i].output = 0;
            }
          }
        }
        DecodeurContent();
        break; 
      case 1:
        Msg = "Dcc Detected : ";
        Msg += String(address);
        Serial.println(Msg);
        Msg = Cmd_DccAdress;
        Msg += String(address);
        Msg += " pour sauvegarder !";
        Serial.println(Msg);
        break;
    }
  }
}

void DecodeurContent() {
  Serial.print("ACC decodeur content : ");
  Serial.print(gAddresses[0].address);
  Serial.print(" - ");
  Serial.println(gAddresses[maxfunctions-1].address);
  int k1=0;
  int k2=0;
  for (int i=maxfunctions-1; i>=0; i--) {
    Serial.print(gAddresses[i].address);
    Serial.print(" ");
  }
  Serial.println();
  for (int i=maxfunctions-1; i>=0; i--) {
    Serial.print(gAddresses[i].output);
    k1=2*k1+gAddresses[i].output;
  }
  Serial.println();
  Serial.print(k1);
  Serial.print(" >>> ");
  Serial.print(k1,BIN);
  Serial.print(" : ");
  String Msg;
  switch (k1) {
    case 0:   
      Msg="Fermeture PN    ";
      gfunction[0].Etat=false;
      break; 
    case 1:   
      Msg="Ouverture PN    ";
      gfunction[0].Etat=true;
      break; 
  }
  Serial.println(Msg);
  lcm1602(0,0,Msg);
}  

// ========================================================
// USB Serial event reader
// ========================================================
void serialEvent() {
  while (Serial.available()) {
    // acquire new character:
    char inChar = (char)Serial.read(); 
    // if it is LF, set flag for so main loop takes message into account:
    if (inChar == '\n') {
      stringComplete = true;
    } else {
    // else add this character to being build message:
      inputString += inChar;
    }
  }
}


// ========================================================
// Display Parameters
void List() {
  Serial.print(Msg_DccAdress);Serial.print(" : "); Serial.println(DccBaseAdress);
  Serial.print(Msg_Move);Serial.print(" : ");Serial.println(speedPN);
  Serial.print(Msg_Toggle);Serial.print(" : ");Serial.println(Period);
  Serial.print(Msg_Delay);Serial.print(" : ");Serial.println(tempoPN);
  Serial.print("Servo ");
  for (int i=0;i<16; i++) {
    Serial.print(i);Serial.print(" ");
  }
  Serial.println();
  Serial.print("Min   ");
  for (int i=0;i<16; i++) {
    Serial.print(MinValue[i]);Serial.print(" ");
  }
  Serial.println();
  Serial.print("Max   ");
  for (int i=0;i<16; i++) {
    Serial.print(MaxValue[i]);Serial.print(" ");  
  }
  Serial.println();
}
// ========================================================
// Display help (list of available commands)
void Help() {
  Serial.println(Msg_Servo);
  Serial.print(Cmd_DccAdress);Serial.print(" : "); Serial.println(Msg_DccAdress);
  Serial.print(Cmd_DccMode);Serial.print(" : "); Serial.println(Msg_DccMode);
  Serial.print(Cmd_Cmd);Serial.print(" : "); Serial.println(Msg_Cmd);
  Serial.print(Cmd_Move);Serial.print(" : "); Serial.println(Msg_Move);
  Serial.print(Cmd_RNr);Serial.print(" : "); Serial.println(Msg_RNr);
  Serial.print(Cmd_RMin);Serial.print(" : "); Serial.println(Msg_RMin);
  Serial.print(Cmd_RMax);Serial.print(" : "); Serial.println(Msg_RMax);
  Serial.print(Cmd_Toggle);Serial.print(" : "); Serial.println(Msg_Toggle);
  Serial.print(Cmd_Delay);Serial.print(" : "); Serial.println(Msg_Delay);

  Serial.print(Cmd_List);Serial.print(" : "); Serial.println(Msg_List);

  Serial.print(Cmd_Store_actual);Serial.print(" : "); Serial.println(Msg_Store_actual);
  Serial.print(Cmd_Dump);Serial.print(" : "); Serial.println(Msg_Dump);

  Serial.print(Cmd_Help);Serial.print(" : "); Serial.println(Msg_Help);
  Serial.print(Cmd_Id);Serial.print(" : "); Serial.println(Msg_Id);
  Serial.println();
}

// ========================================================
// Line, Column, Message
// ========================================================
void lcm1602(int l, int c, String msg) 
{
//  lcd.setCursor(c,l);
////  lcd.print(msg);
  for (int i=0;i<msg.length();i++) {
//    lcd.print(msg.substring(i,i+1));
  }    
}  

// ========================================================
// BlinkPeriod
// ========================================================
void BlinkPeriod(int Port) {
  unsigned long currentMillis = millis();
  unsigned long currentStepMillis = millis();
  if (fadeValue[Port]!=255 && fadeValue[Port]!=0) {
    if (currentStepMillis - previousBlinkStepMillis >= speedFade) {
      // save the last time you blinked the LED
      previousBlinkStepMillis = currentStepMillis;
      if (ledState == LOW){
        if (fadeValue[Port]<255) {
          fadeValue[Port]+=stepFade;
        } else ledState = HIGH;
      } else {
        if (fadeValue[Port]>0) {
          fadeValue[Port]-=stepFade;
        } else ledState = LOW;
      }
      analogWrite(LedPin[0], fadeValue[Port]);
      analogWrite(LedPin[2], fadeValue[Port]);
      analogWrite(LedPin[3], fadeValue[Port]);
      analogWrite(LedPin[4], fadeValue[Port]);
    }    
  }
  if (currentMillis - previousBlinkMillis >= Period) {
    // save the last time you blinked the LED
    previousBlinkMillis = currentMillis;
    // if the LED is off turn it on and vice-versa:
    if (ledState == LOW){
//      Serial.print(" LOW => HIGH ");
      ledState = HIGH;
      fadeValue[Port]=255-stepFade;
    } else {
//      Serial.print(" HIGH => LOW ");
      ledState = LOW;
      fadeValue[Port]=stepFade;
    }
//    Serial.println();
  }  
}
// ========================================================
// ServoMove
//  Move Servo to Angle
//  if MoveValue[Port]!=MinValue[Port]
//  && MoveValue[Port]!=MaxValue[Port]
// ========================================================
void ServoMove(int Port, int Angle) {
  unsigned long currentMillis = millis();
  unsigned long currentStepMillis = millis();
//  Serial.print("Move ");
  if (MoveValue[Port]!=MaxValue[Port] && MoveValue[Port]!=MinValue[Port]) {
//    Serial.print("* ");
    if (currentStepMillis - previousMoveStepMillis >= speedPN) {
      // save the last time you blinked the LED
      previousMoveStepMillis = currentStepMillis;
//        Serial.print(Port);
//        Serial.print(" : ");
//        Serial.print(MoveValue[Port]);
//        Serial.print(" / ");
//        Serial.print(Angle);
//        Serial.print(" ( ");
//        Serial.print(MinValue[Port]);
//        Serial.print(" ; ");
//        Serial.print(MaxValue[Port]);
//        Serial.print(" ) ");
      if (MoveValue[Port] != Angle){
        if (MoveValue[Port]<Angle) {
          MoveValue[Port]+=stepPN;
//          Serial.print(">");
        } else if (MoveValue[Port]>Angle) {
          MoveValue[Port]-=stepPN;
//          Serial.print("<");
        } 
      }
//      Serial.print(MoveValue[Port]);
//      Serial.println();   
      PnServo[0].write(MoveValue[Port]);
      PnServo[1].write(MoveValue[Port]);
      //analogWrite(Port, MoveValue[Port]);
    }    
  }
}
// ========================================================
// Setup (once)
// ========================================================
void setup() {
//  lcd.init();                      // initialize the lcd NOT IN LIB
//  lcd.backlight();                 // Retro eclairage
//  lcm1602(0,0,"Bonjour     ");
//  delay(1000);                     //YD0227 DELAY SUPPRESSED
//  lcm1602(0,0,"            ");
  Serial.begin(9600);
  //music.init();                    // Initialize the Itead MP3 shield
  pinMode(ledPin, OUTPUT);
  PnServo[0].attach(6);
  PnServo[1].attach(5);
  LedPin[0]=13;
  LedPin[1]=9;
  LedPin[2]=10;
  LedPin[3]=11;
  inputString.reserve(100);        // reserve 100 bytes for USB string being build:
  DccBaseAdress=EEPROM.read(Eeprom)*255+EEPROM.read(Eeprom+1);
  speedPN=EEPROM.read(Eeprom+50);
  Period=EEPROM.read(Eeprom+52)*255+EEPROM.read(Eeprom+53);
  tempoPN=EEPROM.read(Eeprom+54)*255+EEPROM.read(Eeprom+55);
  for (int i=0; i<16; i++) {
    gfunction[i].Etat=false;
  }
  for (int i=0; i<16; i++) {      // Initalize Min and Max angles
    MinValue[i]= EEPROM.read(Eeprom+10+i);
    MaxValue[i]= EEPROM.read(Eeprom+30+i);
  }
  List();
  ConfigureDecoderFunctions();
  DCC.SetBasicAccessoryDecoderPacketHandler(BasicAccDecoderPacket_Handler, true);
  DCC.SetupDecoder( 0x00, 0x00, kDCC_INTERRUPT );
//   digitalWrite(PowerPin, HIGH);    // YD0227 Switch on Servo Power AFTER nr check
  Help();
  DecodeurContent();
  //attachInterrupt(0, Power_Down, RISING);
}

// ========================================================
// Main loop
// ========================================================
void loop() { 
  unsigned long currentPNMillis = millis();

// pinMode( gAddresses[5].outputPin, OUTPUT );
//Serial.print("start loop, nr = ");
//Serial.println(nr);
  static int addr = 0;

// Loop DCC library
  DCC.loop();    
  // Jump to next address to test
  if( ++addr >= maxfunctions ) {
    addr = 0;
  }    

// USB received data management: 
    if (stringComplete) {
    inputString.toUpperCase();
    Serial.print(Msg_Recu_USB);
    Serial.println(inputString);
    String c = inputString.substring(0,1);
    int V=inputString.substring(1).toInt();
    if (c==Cmd_Help) {              // ...................... Help (Aide)
      Help();
    } else if (c==Cmd_List) {       // ...................... List Parameters
      List();
    } else if (c==Cmd_DccMode) {    // ...................... Detect Address
      Mode = V;
      Serial.print(Msg_DccMode);
      Serial.println(V);
    } else if (c==Cmd_DccAdress) {  // ...................... Set Address (Selection Adresse)
      EEPROM.write(Eeprom, V/255);
      EEPROM.write(Eeprom+1, V%255);
      Serial.print(Msg_DccAdress);
      DccBaseAdress=EEPROM.read(Eeprom)*255+EEPROM.read(Eeprom+1);
      Serial.println(DccBaseAdress);
      ConfigureDecoderFunctions();
      DecodeurContent();
      Mode=0;
    } else if (c==Cmd_Move) {       // ...  Vitesse Ouverture Fermeture
      // Eeprom+50             : Speed Servo (1)          50
      EEPROM.write(Eeprom+50, V);
      speedPN=EEPROM.read(Eeprom+50);
    } else if (c==Cmd_RNr) {        // ...  Selection Servo
      Serial.print(Msg_RNr);
      Serial.println(V);     
      SelServo=V;
    } else if (c==Cmd_RMin) {        // ...  Angle Mini
      MinValue[SelServo]=V;
      EEPROM.write(Eeprom+10+SelServo, V);
      Serial.print(Msg_RMin);
      Serial.print(" ");
      Serial.print(SelServo);
      Serial.print(" : ");
      Serial.println(V);
      // Eeprom+2n+2           : minangle (n)             2 4 6 8 10 12 14 16
    } else if (c==Cmd_RMax) {        // ...  Angle Maxi
      MaxValue[SelServo]=V;
      EEPROM.write(Eeprom+30+SelServo, V);
      Serial.print(Msg_RMax);
      Serial.print(" ");
      Serial.print(SelServo);
      Serial.print(" : ");
      Serial.println(V);
      // Eeprom+2n+3           : maxangle (n)             3 5 7 9 11 13 15 17
    } else if (c==Cmd_Toggle) {     // ...  Vitesse Clignotement
      // Eeprom+52             : Speed blink (1)          52
      EEPROM.write(Eeprom+52, V/255);
      EEPROM.write(Eeprom+53, V%255);
      Period=EEPROM.read(Eeprom+52)*255+EEPROM.read(Eeprom+53);
      Serial.println(DccBaseAdress);
    } else if (c==Cmd_Delay) {      // ...  Temporisation Feux PN
      // Eeprom+54             : Tempo PN (1)             54
      EEPROM.write(Eeprom+54, V/255);
      EEPROM.write(Eeprom+55, V%255);
      tempoPN=EEPROM.read(Eeprom+54)*255+EEPROM.read(Eeprom+55);
      Serial.println(DccBaseAdress);
    } else if (c==Cmd_Cmd) {        // ...  Commande LDT
      gAddresses[0].output=V%2;
      gAddresses[1].output=V/2%2;
      gAddresses[2].output=V/4%2;
      gAddresses[3].output=V/8%2;
      gAddresses[4].output=V/16%2;
      gAddresses[5].output=V/32%2;
      gAddresses[6].output=V/64%2;
      gAddresses[7].output=V/128%2;
      DccAction = millis();
      done =false;
//      Serial.print(done);
//      Serial.print(" ");
//      Serial.print(DccAction);
//      Serial.println(" ms");      
      cptDown=255;
      cptUp=0;
      previousPNMillis = currentPNMillis;
      //DecodeurContent();
    } else if (c==Cmd_Store_actual) {   // ...  save actual positions
      Power_Down();
    } else if (c==Cmd_Dump) {       // ...  Dump Eeprom
      Eeprom_dump();
    } else if (c==Cmd_Id) {         // ...................... Who ?
      //Serial.print(Msg_Id);
      Serial.println(Msg_Servo);
    } else Serial.println("unknown message"); 
    // re-initialize received string:
    inputString = "";
    stringComplete = false;
  }

  if (gAddresses[0].output) {
//  if (gfunction[0].Etat) {
    //music.play();
    BlinkPeriod(ledPin);
    if (MoveValue[6]==MaxValue[6]) MoveValue[6]-=stepPN;
    if (currentPNMillis - previousPNMillis >= tempoPN) {
      ServoMove(6,MinValue[6]);
    }
  } else {
    if (fadeValue[ledPin]!=0 || MoveValue[6]!=MaxValue[6] ) BlinkPeriod(ledPin);
    //music.pause();
    if (MoveValue[6]==MinValue[6]) MoveValue[6]+=stepPN;
    ServoMove(6,MaxValue[6]);
  }

      
//  if ((millis()-DccAction)>timer && !done) {    
//    if (cptDown>0) {
//      cptDown-=1;
//    } else {
//      if (cptUp<255) {
//        cptUp+=1;
//      } else {
//        done=true;        
//      }
//    }
//    if (!done) {
//      String Msg=String(cptDown) + " " + String(cptUp) + "    ";
//      lcm1602(1,0,Msg);
//    } else DecodeurContent();
//  }  
}

// ========================================================
// Power_down detected
// ========================================================

void Power_Down() {
//    Serial.println("YD0223 power fail");
  Serial.println(Msg_Store_actual);  
//  for (int i=0; i<maxservos; i++) {
//    //to be adapted to I2C Eprom 
//    EEPROM.write(Eeprom+30+i,servos[i].angle);     
//    EEPROM.write(Eeprom+40+i,servos[i].output); 
//  }
}

// ========================================================
// Dump Eeprom content to check content (Debug)
// ========================================================
void Eeprom_dump() {
  for (int i=0;i<6;i++) {
    for (int j=0;j<10;j++) {
      int temp=EEPROM.read(Eeprom+i*10+j);
      Serial.print(temp);
      if (temp<10) {
        Serial.print("   ");
      } else if (temp<100) {
        Serial.print("  ");
      } else {
        Serial.print(" ");
      }
    }    
    Serial.println();
  }
}
